import react_native_image_picker from "react-native-image-picker";
import { isNullOrEmpty } from "fable-core/String";
export function showImagePicker(props, f) {
    react_native_image_picker.showImagePicker(props, f);
}
export function showImagePickerAsync(props) {
    return new Promise(function (onSuccess, onError) {
        showImagePicker(props, function (result) {
            if (!result.didCancel) {
                if (isNullOrEmpty(result.error)) {
                    onSuccess(result.uri);
                } else {
                    onError(new Error(result.error));
                }
            } else {
                onSuccess(null);
            }
        });
    });
}
export function launchCamera(props, f) {
    react_native_image_picker.launchCamera(props, f);
}
export function launchImageLibrary(props, f) {
    react_native_image_picker.launchImageLibrary(props, f);
}
//# sourceMappingURL=Fable.Helpers.ReactNativeImagePicker.js.map